local data = SkillTreeTweakData.init
function SkillTreeTweakData:init(tweak_data)
	data(self, tweak_data)
	local digest = function(value)
		return Application:digest_value(value, true)
	end
	self.tier_unlocks = {
		digest(0),
		digest(1),
		digest(3),
		digest(18)
	}

	local function find_enforcer (tab, val)
	    for index, value in ipairs(tab) do
	        if value.name_id == val then
	        	value.tiers = {
					{"scavenging","predator_saw_swap_speed_multiplier"},
					{
						"ammo_reservoir",
						"portable_saw",
						"predator_saw_reload_speed_multiplier",
						"predator_butcher_saw_extra_ammo_multiplier"
					},
					{
						"ammo_2x",
						"carbon_blade",
						"predator_saw_consume_no_ammo_chance",
						"predator_saw_damage_multiplier"
					},
					{"bandoliers"}
				}
	            return true
	        end
	    end
	    return false
	end

	log('enforcer_init:')
	log(tostring(find_enforcer(self.trees ,"st_menu_enforcer_ammo")))


	--Tier 1

		self.skills.predator_saw_swap_speed_multiplier = { -- consume_no_ammo_chance
			["name_id"] = "menu_saw_swap_speed_multiplier",
			["desc_id"] = "menu_saw_swap_speed_multiplier_desc",
			["icon_xy"] = {4, 11},
			[1] = {
				upgrades = {
					"saw_swap_speed_multiplier_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"saw_swap_speed_multiplier_2"
				},
				cost = self.costs.pro
			}
		}

	--Tier 2



		self.skills.predator_saw_reload_speed_multiplier = { -- consume_no_ammo_chance
			["name_id"] = "menu_saw_reload_speed_multiplier",
			["desc_id"] = "menu_saw_reload_speed_multiplier_desc",
			["icon_xy"] = {10, 5},
			[1] = {
				upgrades = {
					"saw_reload_speed_multiplier_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"saw_reload_speed_multiplier_2"
				},
				cost = self.costs.pro
			}
		}

		self.skills.predator_butcher_saw_extra_ammo_multiplier= { -- consume_no_ammo_chance
			["name_id"] = "menu_butcher_saw_extra_ammo_multiplier",
			["desc_id"] = "menu_butcher_saw_extra_ammo_multiplier_desc",
			["icon_xy"] = {8, 7},
			[1] = {
				upgrades = {
					"butcher_saw_extra_ammo_multiplier_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"butcher_saw_extra_ammo_multiplier_2",
					"player_saw_speed_multiplier_2",
					"saw_lock_damage_multiplier_2"
				},
				cost = self.costs.pro
			}
		}

				
				
	--Tier 3

		self.skills.predator_saw_consume_no_ammo_chance = { -- consume_no_ammo_chance
			["name_id"] = "menu_saw_consume_no_ammo_chance",
			["desc_id"] = "menu_saw_consume_no_ammo_chance_desc",
			["icon_xy"] = {0, 1},
			[1] = {
				upgrades = {
					"saw_consume_no_ammo_chance_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"saw_consume_no_ammo_chance_2"
				},
				cost = self.costs.pro
			}
		}

		self.skills.predator_saw_damage_multiplier= { -- Accuracy BOOST
			["name_id"] = "menu_saw_damage_multiplier",
			["desc_id"] = "menu_saw_damage_multiplier_desc",
			["icon_xy"] = {2, 2},
			[1] = {
				upgrades = {
					"saw_damage_multiplier_1"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"saw_damage_multiplier_2"
				},
				cost = self.costs.pro
			}
		}

	--Tier 3 end

-- Skill cost infos
-- Tier 0 and 1
--       base = self.costs.default
--       aced = self.costs.pro

-- Tier 2 and 3
--       base = self.costs.hightier
--       aced = self.costs.hightierpro


	 

end