local data = UpgradesTweakData.init
function UpgradesTweakData:init(tweak_data)
	data(self, tweak_data)
	-- default values

	self.values.sentry_gun.cost_reduction = {2, 3,0,4}
	self.values.sentry_gun.infinite_ammo = {true}
	self.values.sentry_gun.range_boost = {1.25,1.50}
	self.values.sentry_gun.cooldown_boost = {0.25,0.50}
	self.values.sentry_gun.duration_boost = {1.25,1.50}
	self.values.sentry_gun.damage_boost = {1.15,1.30}
	self.values.sentry_gun.mark_boost = {1,2}


	self.definitions.dragon_cost_reduction = {
		category = "feature",
		name_id = "menu_sentry_gun_cost_reduction",
		upgrade = {
			category = "sentry_gun",
			upgrade = "cost_reduction",
			value = 4
		}
	}

	self.definitions.sentry_gun_infinite_ammo = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_infinite_ammo",
		upgrade = {
			category = "sentry_gun",
			upgrade = "infinite_ammo",
			value = 1
		}
	}

	self.definitions.sentry_gun_range_boost_1 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_range_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "range_boost",
			value = 1
		}
	}

	self.definitions.sentry_gun_range_boost_2 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_range_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "range_boost",
			value = 2
		}
	}

	self.definitions.sentry_gun_duration_boost_1 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_duration_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "duration_boost",
			value = 1
		}
	}

	self.definitions.sentry_gun_duration_boost_2 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_duration_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "duration_boost",
			value = 2
		}
	}


	self.definitions.sentry_gun_cooldown_boost_1 = {
			category = "feature",
			incremental = true,
			name_id = "menu_sentry_gun_cooldown_boost",
			upgrade = {
				category = "sentry_gun",
				upgrade = "cooldown_boost",
				value = 1
			}
		}

	self.definitions.sentry_gun_cooldown_boost_2 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_cooldown_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "cooldown_boost",
			value = 2
		}
	}


	self.definitions.sentry_gun_mark_boost_1 = {
			category = "feature",
			incremental = true,
			name_id = "menu_sentry_gun_mark_boost",
			upgrade = {
				category = "sentry_gun",
				upgrade = "mark_boost",
				value = 1
			}
		}

	self.definitions.sentry_gun_mark_boost_2 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_mark_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "mark_boost",
			value = 2
		}
	}

	self.definitions.sentry_gun_damage_boost_1 = {
			category = "feature",
			incremental = true,
			name_id = "menu_sentry_gun_damage_boost",
			upgrade = {
				category = "sentry_gun",
				upgrade = "damage_boost",
				value = 1
			}
		}

	self.definitions.sentry_gun_damage_boost_2 = {
		category = "feature",
		incremental = true,
		name_id = "menu_sentry_gun_damage_boost",
		upgrade = {
			category = "sentry_gun",
			upgrade = "damage_boost",
			value = 2
		}
	}



end


