local data = SkillTreeTweakData.init
function SkillTreeTweakData:init(tweak_data)
	data(self, tweak_data)
	local digest = function(value)
		return Application:digest_value(value, true)
	end
	self.tier_unlocks = {
		digest(0),
		digest(1),
		digest(3),
		digest(18)
	}

-- I like to use table.insert because self.skill_pages_order is a table and 
-- using th insert it won't overrie the skill tree of the other modders
-- log(tostring(type(self.skill_pages_order)))

	local function contain_my_skilltree (tab, val)
	    for index, value in ipairs(tab) do
	        if value == val then
	            return true
	        end
	    end
	    return false
	end
	if not contain_my_skilltree(self.skill_pages_order,"predator") then
		table.insert(self.skill_pages_order,"predator")
		self.skilltree.predator = {
			name_id = "predator_skilltree",
			desc_id = "predator_skilltree_desc"
		}
	end



-- Skill cost infos
-- Tier 0 and 1
--       base = self.costs.default
--       aced = self.costs.pro

-- Tier 2 and 3
--       base = self.costs.hightier
--       aced = self.costs.hightierpro


self.skills.dragon_sentry = {  
	["name_id"] = "menu_predator_dragon_sentry",
	["desc_id"] = "menu_predator_dragon_sentry_desc",
	["icon_xy"] = {9, 2},
	[1] = {
		upgrades = {
			"dragon_cost_reduction",
			"sentry_gun_infinite_ammo",
			"rot_speed_multiplier"
		},
		cost = self.costs.default
	},
	[2] = {
		upgrades = {

		},
		cost = self.costs.pro
	}
}

self.skills.dragon_damage = {  
	["name_id"] = "menu_predator_dragon_damage",
	["desc_id"] = "menu_predator_dragon_damage_desc",
	["icon_xy"] = {9, 2},
	[1] = {
		upgrades = {
			"sentry_gun_damage_boost_1"
		},
		cost = self.costs.default
	},
	[2] = {
		upgrades = {
			"sentry_gun_damage_boost_2"
		},
		cost = self.costs.pro
	}
}

self.skills.dragon_range = {  
	["name_id"] = "menu_predator_dragon_range",
	["desc_id"] = "menu_predator_dragon_range_desc",
	["icon_xy"] = {9, 2},
	[1] = {
		upgrades = {
			"sentry_gun_range_boost_1"
		},
		cost = self.costs.default
	},
	[2] = {
		upgrades = {
			"sentry_gun_range_boost_2"
		},
		cost = self.costs.pro
	}
}

self.skills.dragon_battery = {  
	["name_id"] = "menu_predator_dragon_battery",
	["desc_id"] = "menu_predator_dragon_battery_desc",
	["icon_xy"] = {9, 2},
	[1] = {
		upgrades = {
			"sentry_gun_duration_boost_1",
			"sentry_gun_cooldown_boost_1"
		},
		cost = self.costs.hightier
	},
	[2] = {
		upgrades = {
			"sentry_gun_duration_boost_2",
			"sentry_gun_cooldown_boost_1"
		},
		cost = self.costs.hightier
	}
}

self.skills.dragon_sensor = {  
	["name_id"] = "menu_predator_dragon_sensor",
	["desc_id"] = "menu_predator_dragon_sensor_desc",
	["icon_xy"] = {9, 2},
	[1] = {
		upgrades = {
			"sentry_gun_mark_boost_1"
		},
		cost = self.costs.hightier
	},
	[2] = {
		upgrades = {
			"sentry_gun_mark_boost_2"
		},
		cost = self.costs.hightier
	}
}

self.skills.dragon_final = {  
	["name_id"] = "menu_predator_dragon_final",
	["desc_id"] = "menu_predator_dragon_final_desc",
	["icon_xy"] = {9, 9},
	[1] = {
		upgrades = {

		},
		cost = self.costs.hightier
	},
	[2] = {
		upgrades = {

		},
		cost = self.costs.hightier
	}
}


-- This is for insert our skill tre in main tree
table.insert(self.trees,{
			name_id = "predator_dragon_tree",-- id for localization
			background_texture = "guis/textures/pd2/skilltree/bg_mastermind",
			unlocked = true,
			skill = "predator", -- the name of your skilltree
			tiers = {
					{
						"dragon_sentry"
					},
					{
						"dragon_damage",
						"dragon_range"
					},
					{
						"dragon_battery",
						"dragon_sensor"
					}, 
					{
						"dragon_final"
					} 
				}
			})	

end

--[[
------TIER0------
"Dragon sentry"
-- Infos 
-- Base: You unlock the new incediary sentry. The sentry has infinite ammo. The sentry battery lasts 60 seconds. The range of the sentry is 10mt. The sentry cooldown is 60 seconds. Maybe the sentry will use a custom model
-- Pro:  Your damage is increased by 15% against burning targets. 
------TIER1------
"TBD"
-- Base: The sentry range is now increased by 25%
-- Pro : The sentry range is now increased by an additional 25%
"TBD"       
-- Base:
-- Pro :
------TIER2------
"TBD"
-- Base:
-- Pro :
"TBD"
-- Base: 
-- Pro : 
------TIER3------
"TBD" 
-- Base: 
-- Pro : 
]]