local data = UpgradesTweakData.init
function UpgradesTweakData:init(tweak_data)
	data(self, tweak_data)

	-- LMGs Skills
		self.values.lmg.reload_speed_multiplier = {1.2, 1.5}
		self.values.lmg.fire_rate_multiplier = {1.20,1.4}
		self.values.lmg.damage_addend = {0.5}
		self.values.lmg.damage_multiplier = {1.20}
		self.values.lmg.extra_ammo_multiplier = {1.25,1.50}
		self.values.lmg.spread_index_addend = {2,3}
		self.values.minigun.reload_speed_multiplier = {1.2, 1.5}
		self.values.minigun.fire_rate_multiplier = {1.20,1.4}
		self.values.minigun.damage_addend = {0.5}
		self.values.minigun.damage_multiplier = {1.20}
		self.values.minigun.extra_ammo_multiplier = {1.25,1.50}
		self.values.minigun.spread_index_addend = {2,3}


		self.values.player.detection_risk_damage_multiplier = {
			{
				0.05,-- gain 5% dmg for 
				6, -- every x points       
				"above", -- MAX: 7=25% 6=30% 5=40% 4=50% 3=65%
				35 -- above x 
			},
			{
				0.05,
				5,
				"above",
				35
			}
		}

	-- 

	-- LMGs skilltree skills

		self.definitions.lmg_spread_index_addend = {
			category = "feature",
			name_id = "lmg_spread_addend",
			upgrade = {
				category = "lmg",
				upgrade = "spread_index_addend",
				value = 1
			}
		}

		self.definitions.aced_lmg_spread_index_addend = {
			category = "feature",
			name_id = "lmg_spread_addend",
			upgrade = {
				category = "lmg",
				upgrade = "spread_index_addend",
				value = 2
			}
		}

		self.definitions.lmg_reload_speed = {
			category = "feature",
			name_id = "lmg_reload_speed",
			upgrade = {
				category = "lmg",
				upgrade = "reload_speed_multiplier",
				value = 1
			}
		}
		self.definitions.aced_lmg_reload_speed = {
			category = "feature",
			name_id = "aced_lmg_reload_speed",
			upgrade = {
				category = "lmg",
				upgrade = "reload_speed_multiplier",
				value = 2
			}
		}
		self.definitions.lmg_firerate = {
			category = "feature",
			name_id = "lmg_firerate",
			upgrade = {
				category = "lmg",
				upgrade = "fire_rate_multiplier",
				value = 1
			}
		}
		self.definitions.aced_lmg_firerate = {
			category = "feature",
			name_id = "lmg_firerate",
			upgrade = {
				category = "lmg",
				upgrade = "fire_rate_multiplier",
				value = 2
			}
		}		
		self.definitions.lmg_damage_addend = {
			category = "feature",
			name_id = "lmg_damage_addend",
			upgrade = {
				category = "lmg",
				upgrade = "damage_addend",
				value = 1
			}
		}
		self.definitions.lmg_damage_multiplier = {
			category = "feature",
			name_id = "lmg_damage_multi",
			upgrade = {
				category = "lmg",
				upgrade = "damage_multiplier",
				value = 1
			}
		}
		self.definitions.lmg_extra_ammo_multiplier = {
			category = "feature",
			name_id = "lmg_extra_ammo_multiplier",
			upgrade = {
				category = "lmg",
				upgrade = "extra_ammo_multiplier",
				value = 1
			}
		}
		self.definitions.aced_lmg_extra_ammo_multiplier = {
			category = "feature",
			name_id = "lmg_extra_ammo_multiplier",
			upgrade = {
				category = "lmg",
				upgrade = "extra_ammo_multiplier",
				value = 2
			}
		}

		self.definitions.predator_detection_risk_damage_multiplier = {
		category = "feature",
		name_id = "predator_detection_risk_damage_multiplier",
		upgrade = {
			category = "player",
			upgrade = "detection_risk_damage_multiplier",
			value = 1
			}
		}

		self.definitions.predator_detection_risk_damage_multiplier_2 = {
		category = "feature",
		name_id = "predator_detection_risk_damage_multiplier",
		upgrade = {
			category = "player",
			upgrade = "detection_risk_damage_multiplier",
			value = 2
			}
		}


	-- /LMG SKILLTREE

		-- miniguns skilltree skills

		self.definitions.minigun_spread_index_addend = {
			category = "feature",
			name_id = "minigun_spread_addend",
			upgrade = {
				category = "minigun",
				upgrade = "spread_index_addend",
				value = 1
			}
		}

		self.definitions.aced_minigun_spread_index_addend = {
			category = "feature",
			name_id = "minigun_spread_addend",
			upgrade = {
				category = "minigun",
				upgrade = "spread_index_addend",
				value = 2
			}
		}

		self.definitions.minigun_reload_speed = {
			category = "feature",
			name_id = "minigun_reload_speed",
			upgrade = {
				category = "minigun",
				upgrade = "reload_speed_multiplier",
				value = 1
			}
		}
		self.definitions.aced_minigun_reload_speed = {
			category = "feature",
			name_id = "aced_minigun_reload_speed",
			upgrade = {
				category = "minigun",
				upgrade = "reload_speed_multiplier",
				value = 2
			}
		}
		self.definitions.minigun_firerate = {
			category = "feature",
			name_id = "minigun_firerate",
			upgrade = {
				category = "minigun",
				upgrade = "fire_rate_multiplier",
				value = 1
			}
		}
		self.definitions.aced_minigun_firerate = {
			category = "feature",
			name_id = "minigun_firerate",
			upgrade = {
				category = "minigun",
				upgrade = "fire_rate_multiplier",
				value = 2
			}
		}		
		self.definitions.minigun_damage_addend = {
			category = "feature",
			name_id = "minigun_damage_addend",
			upgrade = {
				category = "minigun",
				upgrade = "damage_addend",
				value = 1
			}
		}
		self.definitions.minigun_damage_multiplier = {
			category = "feature",
			name_id = "minigun_damage_multi",
			upgrade = {
				category = "minigun",
				upgrade = "damage_multiplier",
				value = 1
			}
		}
		self.definitions.minigun_extra_ammo_multiplier = {
			category = "feature",
			name_id = "minigun_extra_ammo_multiplier",
			upgrade = {
				category = "minigun",
				upgrade = "extra_ammo_multiplier",
				value = 1
			}
		}
		self.definitions.aced_minigun_extra_ammo_multiplier = {
			category = "feature",
			name_id = "minigun_extra_ammo_multiplier",
			upgrade = {
				category = "minigun",
				upgrade = "extra_ammo_multiplier",
				value = 2
			}
		}

	-- /minigun SKILLTREE


end