local data = SkillTreeTweakData.init
function SkillTreeTweakData:init(tweak_data)
	data(self, tweak_data)
	local digest = function(value)
		return Application:digest_value(value, true)
	end
	self.tier_unlocks = {
		digest(0),
		digest(1),
		digest(3),
		digest(18)
	}

	local function find_technician (tab, val)
	    for index, value in ipairs(tab) do
	        if value.name_id == val then
	        	value.tiers = {
					{
						"steady_grip",
						"predator_lmg_accuracy_boost"
					},
					{
						"heavy_impact",
						"fire_control",
						"lmg_rof_boost",
						"predator_lmg_reload_speed"
					},
					{
						"shock_and_awe",
						"fast_fire",
						"predator_lmg_damage_boost",
						"predator_lmg_ammo_boost"
					},
					{
						"body_expertise",
						"predator_conc_dmg_boost"
					}
				}
	            return true
	        end
	    end
	    return false
	end

	log('technician_init:')
	log(tostring(find_technician(self.trees ,"st_menu_technician_auto")))

-- Skill cost infos
-- Tier 0 and 1
--       base = self.costs.default
--       aced = self.costs.pro

-- Tier 2 and 3
--       base = self.costs.hightier
--       aced = self.costs.hightierpro


	--- LMG SKILLS

		self.skills.predator_lmg_accuracy_boost = { -- Accuracy BOOST
			["name_id"] = "menu_lmg_accuracy_boost",
			["desc_id"] = "menu_lmg_accuracy_boost_desc",
			["icon_xy"] = {8, 5},
			[1] = {
				upgrades = {
					"lmg_spread_index_addend","minigun_spread_index_addend"
				},
				cost = self.costs.default
			},
			[2] = {
				upgrades = {
					"aced_lmg_spread_index_addend","aced_minigun_spread_index_addend"
				},
				cost = self.costs.pro
			}
		}

		-- TIER 2
			self.skills.lmg_rof_boost = { -- RATE OF FIRE BOOST
				["name_id"] = "menu_lmg_Firerate_boost",
				["desc_id"] = "menu_lmg_Firerate_boost_desc",
				["icon_xy"] = {1, 9},
				[1] = {
					upgrades = {
						"lmg_firerate","minigun_firerate"
					},
					cost = self.costs.default
				},
				[2] = {
					upgrades = {
						"aced_lmg_firerate","aced_minigun_firerate"
					},
					cost = self.costs.pro
				}
			}

			self.skills.predator_lmg_reload_speed = { -- RELOAD SPEED BOOST
				["name_id"] = "menu_lmg_reload_speed",
				["desc_id"] = "menu_lmg_reload_speed_desc",
				["icon_xy"] = {5, 1},
				[1] = {
					upgrades = {
						"lmg_reload_speed","minigun_reload_speed"
					},
					cost = self.costs.default
				},
				[2] = {
					upgrades = {
						"aced_lmg_reload_speed","aced_minigun_reload_speed"
					},
					cost = self.costs.pro
				}
			}
		-- TIER 2 END
		-- TIER 3 
			self.skills.predator_lmg_damage_boost = { -- DAMAGE BOOST
				["name_id"] = "menu_lmg_damage_boost",
				["desc_id"] = "menu_lmg_damage_boost_desc",
				["icon_xy"] = {2, 2},
				[1] = {
					upgrades = {
						"lmg_damage_addend",
						"minigun_damage_addend"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"lmg_damage_multiplier",
						"minigun_damage_multiplier"
					},
					cost = self.costs.hightierpro
				}
			}

			self.skills.predator_lmg_ammo_boost = { -- Ammunition BOOST
				["name_id"] = "menu_lmg_ammo_boost",
				["desc_id"] = "menu_lmg_ammo_boost_desc",
				["icon_xy"] = {3, 0},
				[1] = {
					upgrades = {
						"lmg_extra_ammo_multiplier","minigun_extra_ammo_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"aced_lmg_extra_ammo_multiplier","aced_minigun_extra_ammo_multiplier"
					},
					cost = self.costs.hightierpro
				}
			}

			self.skills.predator_conc_dmg_boost = { -- Ammunition BOOST
				["name_id"] = "menu_predator_conc_dmg_boost",
				["desc_id"] = "menu_predator_conc_dmg_boost_desc",
				["icon_xy"] = {4, 11},
				[1] = {
					upgrades = {
						"predator_detection_risk_damage_multiplier"
					},
					cost = self.costs.hightier
				},
				[2] = {
					upgrades = {
						"predator_detection_risk_damage_multiplier_2"
					},
					cost = self.costs.hightierpro
				}
			}
		-- TIER 3 END

	--- 

end